﻿Shader "Unlit/LAOutline"
{
    Properties
    {
        _OutlineColor("Outline Color", Color) = (0,1,0,0)
_ScaleFactor("Scale Factor ", Float) = 0.1

    }
        SubShader
    {
        Tags
        {
            "RenderPipeline" = "LightweightPipeline"
            "RenderType" = "Transparent"
            "Queue" = "Transparent+0"
        }
        Pass
        {
        // Material options generated by graph

        Blend SrcAlpha OneMinusSrcAlpha, One OneMinusSrcAlpha

        Cull Off

        ZTest LEqual

        ZWrite Off

        HLSLPROGRAM
        // Required to compile gles 2.0 with standard srp library
        #pragma prefer_hlslcc gles
        #pragma exclude_renderers d3d11_9x
        #pragma target 2.0

        // -------------------------------------
        // Lightweight Pipeline keywords
        #pragma shader_feature _SAMPLE_GI

        // -------------------------------------
        // Unity defined keywords
        #pragma multi_compile _ DIRLIGHTMAP_COMBINED
        #pragma multi_compile _ LIGHTMAP_ON
        #pragma multi_compile_fog

        //--------------------------------------
        // GPU Instancing
        #pragma multi_compile_instancing

        #pragma vertex vert
        #pragma fragment frag

        // Defines generated by graph
        #define _AlphaClip 1

        // Lighting include is needed because of GI
        #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Core.hlsl"
        #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Lighting.hlsl"
        #include "Packages/com.unity.render-pipelines.core/ShaderLibrary/Color.hlsl"
        #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/ShaderGraphFunctions.hlsl"
        #include "Packages/com.unity.render-pipelines.lightweight/Shaders/UnlitInput.hlsl"

        CBUFFER_START(UnityPerMaterial)
        float4 _OutlineColor;
        float _ScaleFactor;
        CBUFFER_END

        struct VertexDescriptionInputs
        {
            float3 WorldSpaceNormal;
            float3 WorldSpaceTangent;
            float3 WorldSpaceBiTangent;
            float3 WorldSpacePosition;
            float3 ViewSpacePosition;
        };

        struct SurfaceDescriptionInputs
        {
            float FaceSign;
        };


        void Unity_Absolute_float(float In, out float Out)
        {
            Out = abs(In);
        }

        void Unity_Multiply_float(float A, float B, out float Out)
        {
            Out = A * B;
        }

        void Unity_Divide_float(float A, float B, out float Out)
        {
            Out = A / B;
        }

        void Unity_Multiply_float(float3 A, float3 B, out float3 Out)
        {
            Out = A * B;
        }

        void Unity_Add_float3(float3 A, float3 B, out float3 Out)
        {
            Out = A + B;
        }

        void Unity_Branch_float(float Predicate, float True, float False, out float Out)
        {
            Out = lerp(False, True, Predicate);
        }

        struct VertexDescription
        {
            float3 Position;
        };

        VertexDescription PopulateVertexData(VertexDescriptionInputs IN)
        {
            VertexDescription description = (VertexDescription)0;
            float _Property_90A48841_Out_0 = _ScaleFactor;
            float _Split_39131A38_R_1 = IN.ViewSpacePosition[0];
            float _Split_39131A38_G_2 = IN.ViewSpacePosition[1];
            float _Split_39131A38_B_3 = IN.ViewSpacePosition[2];
            float _Split_39131A38_A_4 = 0;
            float _Absolute_CEDA0562_Out_1;
            Unity_Absolute_float(_Split_39131A38_B_3, _Absolute_CEDA0562_Out_1);
            float _Multiply_F0695E26_Out_2;
            Unity_Multiply_float(_Property_90A48841_Out_0, _Absolute_CEDA0562_Out_1, _Multiply_F0695E26_Out_2);
            float4 _MatrixSplit_1C48B3C9_M0_1 = UNITY_MATRIX_P[0];
            float4 _MatrixSplit_1C48B3C9_M1_2 = UNITY_MATRIX_P[1];
            float4 _MatrixSplit_1C48B3C9_M2_3 = UNITY_MATRIX_P[2];
            float4 _MatrixSplit_1C48B3C9_M3_4 = UNITY_MATRIX_P[3];
            float _Split_55F6C55D_R_1 = _MatrixSplit_1C48B3C9_M0_1[0];
            float _Split_55F6C55D_G_2 = _MatrixSplit_1C48B3C9_M0_1[1];
            float _Split_55F6C55D_B_3 = _MatrixSplit_1C48B3C9_M0_1[2];
            float _Split_55F6C55D_A_4 = _MatrixSplit_1C48B3C9_M0_1[3];
            float _Divide_3E0AC35C_Out_2;
            Unity_Divide_float(_ScreenParams.x, _ScreenParams.y, _Divide_3E0AC35C_Out_2);
            float _Multiply_6545A8C7_Out_2;
            Unity_Multiply_float(_Split_55F6C55D_R_1, _Divide_3E0AC35C_Out_2, _Multiply_6545A8C7_Out_2);
            float _Divide_8542C8F7_Out_2;
            Unity_Divide_float(_Multiply_F0695E26_Out_2, _Multiply_6545A8C7_Out_2, _Divide_8542C8F7_Out_2);
            float3 _Multiply_FEB093DF_Out_2;
            Unity_Multiply_float((_Divide_8542C8F7_Out_2.xxx), IN.WorldSpaceNormal, _Multiply_FEB093DF_Out_2);
            float3 _Add_133F45A4_Out_2;
            Unity_Add_float3(_Multiply_FEB093DF_Out_2, IN.WorldSpacePosition, _Add_133F45A4_Out_2);
            float3 _Transform_76279C8F_Out_1 = TransformWorldToObject(_Add_133F45A4_Out_2.xyz);
            description.Position = _Transform_76279C8F_Out_1;
            return description;
        }

        struct SurfaceDescription
        {
            float3 Color;
            float Alpha;
            float AlphaClipThreshold;
        };

        SurfaceDescription PopulateSurfaceData(SurfaceDescriptionInputs IN)
        {
            SurfaceDescription surface = (SurfaceDescription)0;
            float4 _Property_57C4ED2E_Out_0 = _OutlineColor;
            float _IsFrontFace_5A59E25B_Out_0 = max(0, IN.FaceSign);
            float _Branch_18FFF884_Out_3;
            Unity_Branch_float(_IsFrontFace_5A59E25B_Out_0, 0, 1, _Branch_18FFF884_Out_3);
            float _Vector1_252E6EF6_Out_0 = 0.5;
            surface.Color = (_Property_57C4ED2E_Out_0.xyz);
            surface.Alpha = _Branch_18FFF884_Out_3;
            surface.AlphaClipThreshold = _Vector1_252E6EF6_Out_0;
            return surface;
        }

        struct GraphVertexInput
        {
            float4 vertex : POSITION;
            float3 normal : NORMAL;
            float4 tangent : TANGENT;
            float4 texcoord1 : TEXCOORD1;
            UNITY_VERTEX_INPUT_INSTANCE_ID
        };


        struct GraphVertexOutput
        {
            float4 position : POSITION;

            // Interpolators defined by graph
            float3 WorldSpacePosition : TEXCOORD3;
            float3 WorldSpaceNormal : TEXCOORD4;
            float3 WorldSpaceTangent : TEXCOORD5;
            float3 WorldSpaceBiTangent : TEXCOORD6;
            float3 WorldSpaceViewDirection : TEXCOORD7;
            half4 uv1 : TEXCOORD8;

            UNITY_VERTEX_INPUT_INSTANCE_ID
            UNITY_VERTEX_OUTPUT_STEREO
        };

        GraphVertexOutput vert(GraphVertexInput v)
        {
            GraphVertexOutput o = (GraphVertexOutput)0;
            UNITY_SETUP_INSTANCE_ID(v);
            UNITY_TRANSFER_INSTANCE_ID(v, o);
            UNITY_INITIALIZE_VERTEX_OUTPUT_STEREO(o);

            // Vertex transformations performed by graph
            float3 WorldSpacePosition = mul(UNITY_MATRIX_M,v.vertex).xyz;
            float3 WorldSpaceNormal = normalize(mul(v.normal,(float3x3)UNITY_MATRIX_I_M));
            float3 WorldSpaceTangent = normalize(mul((float3x3)UNITY_MATRIX_M,v.tangent.xyz));
            float3 WorldSpaceBiTangent = cross(WorldSpaceNormal, WorldSpaceTangent.xyz) * v.tangent.w;
            float3 WorldSpaceViewDirection = _WorldSpaceCameraPos.xyz - mul(GetObjectToWorldMatrix(), float4(v.vertex.xyz, 1.0)).xyz;
            float4 uv1 = v.texcoord1;
            float3 ViewSpacePosition = mul(UNITY_MATRIX_V,float4(WorldSpacePosition,1.0)).xyz;

            VertexDescriptionInputs vdi = (VertexDescriptionInputs)0;

            // Vertex description inputs defined by graph
            vdi.WorldSpaceNormal = WorldSpaceNormal;
            vdi.WorldSpaceTangent = WorldSpaceTangent;
            vdi.WorldSpaceBiTangent = WorldSpaceBiTangent;
            vdi.WorldSpacePosition = WorldSpacePosition;
            vdi.ViewSpacePosition = ViewSpacePosition;

            VertexDescription vd = PopulateVertexData(vdi);
            v.vertex.xyz = vd.Position;

            o.position = TransformObjectToHClip(v.vertex.xyz);
            // Vertex shader outputs defined by graph
            o.WorldSpacePosition = WorldSpacePosition;
            o.WorldSpaceNormal = WorldSpaceNormal;
            o.WorldSpaceTangent = WorldSpaceTangent;
            o.WorldSpaceBiTangent = WorldSpaceBiTangent;
            o.WorldSpaceViewDirection = WorldSpaceViewDirection;
            o.uv1 = uv1;

            return o;
        }

        half4 frag(GraphVertexOutput IN , half FaceSign : VFACE
    ) : SV_Target
        {
            UNITY_SETUP_INSTANCE_ID(IN);
            UNITY_SETUP_STEREO_EYE_INDEX_POST_VERTEX(IN);

            // Pixel transformations performed by graph
            float3 WorldSpacePosition = IN.WorldSpacePosition;
            float3 WorldSpaceNormal = IN.WorldSpaceNormal;
            float3 WorldSpaceTangent = IN.WorldSpaceTangent;
            float3 WorldSpaceBiTangent = IN.WorldSpaceBiTangent;
            float3 WorldSpaceViewDirection = IN.WorldSpaceViewDirection;
            float4 uv1 = IN.uv1;


            SurfaceDescriptionInputs surfaceInput = (SurfaceDescriptionInputs)0;
            // Surface description inputs defined by graph
            surfaceInput.FaceSign = FaceSign;


            SurfaceDescription surf = PopulateSurfaceData(surfaceInput);
            float3 Color = float3(0.5, 0.5, 0.5);
            float Alpha = 1;
            float AlphaClipThreshold = 0;
            // Surface description remap performed by graph
            Color = surf.Color;
            Alpha = surf.Alpha;
            AlphaClipThreshold = surf.AlphaClipThreshold;


     #if _AlphaClip
            clip(Alpha - AlphaClipThreshold);
    #endif
            return half4(Color, Alpha);
        }
        ENDHLSL
    }
    Pass
    {
        Name "ShadowCaster"
        Tags{"LightMode" = "ShadowCaster"}

        ZWrite On ZTest LEqual

            // Material options generated by graph
            Cull Off

            HLSLPROGRAM
            // Required to compile gles 2.0 with standard srp library
            #pragma prefer_hlslcc gles
            #pragma exclude_renderers d3d11_9x
            #pragma target 2.0

            //--------------------------------------
            // GPU Instancing
            #pragma multi_compile_instancing

            #pragma vertex ShadowPassVertex
            #pragma fragment ShadowPassFragment

            // Defines generated by graph
            #define _AlphaClip 1

            #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Core.hlsl"
            #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Lighting.hlsl"
            #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/ShaderGraphFunctions.hlsl"
            #include "Packages/com.unity.render-pipelines.core/ShaderLibrary/Color.hlsl"

            CBUFFER_START(UnityPerMaterial)
            float4 _OutlineColor;
            float _ScaleFactor;
            CBUFFER_END

            struct VertexDescriptionInputs
            {
                float3 WorldSpaceNormal;
                float3 WorldSpaceTangent;
                float3 WorldSpaceBiTangent;
                float3 WorldSpacePosition;
                float3 ViewSpacePosition;
            };

            struct SurfaceDescriptionInputs
            {
                float FaceSign;
            };


            void Unity_Absolute_float(float In, out float Out)
            {
                Out = abs(In);
            }

            void Unity_Multiply_float(float A, float B, out float Out)
            {
                Out = A * B;
            }

            void Unity_Divide_float(float A, float B, out float Out)
            {
                Out = A / B;
            }

            void Unity_Multiply_float(float3 A, float3 B, out float3 Out)
            {
                Out = A * B;
            }

            void Unity_Add_float3(float3 A, float3 B, out float3 Out)
            {
                Out = A + B;
            }

            void Unity_Branch_float(float Predicate, float True, float False, out float Out)
            {
                Out = lerp(False, True, Predicate);
            }

            struct VertexDescription
            {
                float3 Position;
            };

            VertexDescription PopulateVertexData(VertexDescriptionInputs IN)
            {
                VertexDescription description = (VertexDescription)0;
                float _Property_90A48841_Out_0 = _ScaleFactor;
                float _Split_39131A38_R_1 = IN.ViewSpacePosition[0];
                float _Split_39131A38_G_2 = IN.ViewSpacePosition[1];
                float _Split_39131A38_B_3 = IN.ViewSpacePosition[2];
                float _Split_39131A38_A_4 = 0;
                float _Absolute_CEDA0562_Out_1;
                Unity_Absolute_float(_Split_39131A38_B_3, _Absolute_CEDA0562_Out_1);
                float _Multiply_F0695E26_Out_2;
                Unity_Multiply_float(_Property_90A48841_Out_0, _Absolute_CEDA0562_Out_1, _Multiply_F0695E26_Out_2);
                float4 _MatrixSplit_1C48B3C9_M0_1 = UNITY_MATRIX_P[0];
                float4 _MatrixSplit_1C48B3C9_M1_2 = UNITY_MATRIX_P[1];
                float4 _MatrixSplit_1C48B3C9_M2_3 = UNITY_MATRIX_P[2];
                float4 _MatrixSplit_1C48B3C9_M3_4 = UNITY_MATRIX_P[3];
                float _Split_55F6C55D_R_1 = _MatrixSplit_1C48B3C9_M0_1[0];
                float _Split_55F6C55D_G_2 = _MatrixSplit_1C48B3C9_M0_1[1];
                float _Split_55F6C55D_B_3 = _MatrixSplit_1C48B3C9_M0_1[2];
                float _Split_55F6C55D_A_4 = _MatrixSplit_1C48B3C9_M0_1[3];
                float _Divide_3E0AC35C_Out_2;
                Unity_Divide_float(_ScreenParams.x, _ScreenParams.y, _Divide_3E0AC35C_Out_2);
                float _Multiply_6545A8C7_Out_2;
                Unity_Multiply_float(_Split_55F6C55D_R_1, _Divide_3E0AC35C_Out_2, _Multiply_6545A8C7_Out_2);
                float _Divide_8542C8F7_Out_2;
                Unity_Divide_float(_Multiply_F0695E26_Out_2, _Multiply_6545A8C7_Out_2, _Divide_8542C8F7_Out_2);
                float3 _Multiply_FEB093DF_Out_2;
                Unity_Multiply_float((_Divide_8542C8F7_Out_2.xxx), IN.WorldSpaceNormal, _Multiply_FEB093DF_Out_2);
                float3 _Add_133F45A4_Out_2;
                Unity_Add_float3(_Multiply_FEB093DF_Out_2, IN.WorldSpacePosition, _Add_133F45A4_Out_2);
                float3 _Transform_76279C8F_Out_1 = TransformWorldToObject(_Add_133F45A4_Out_2.xyz);
                description.Position = _Transform_76279C8F_Out_1;
                return description;
            }

            struct SurfaceDescription
            {
                float Alpha;
                float AlphaClipThreshold;
            };

            SurfaceDescription PopulateSurfaceData(SurfaceDescriptionInputs IN)
            {
                SurfaceDescription surface = (SurfaceDescription)0;
                float _IsFrontFace_5A59E25B_Out_0 = max(0, IN.FaceSign);
                float _Branch_18FFF884_Out_3;
                Unity_Branch_float(_IsFrontFace_5A59E25B_Out_0, 0, 1, _Branch_18FFF884_Out_3);
                float _Vector1_252E6EF6_Out_0 = 0.5;
                surface.Alpha = _Branch_18FFF884_Out_3;
                surface.AlphaClipThreshold = _Vector1_252E6EF6_Out_0;
                return surface;
            }

            struct GraphVertexInput
            {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 tangent : TANGENT;
                float4 texcoord1 : TEXCOORD1;
                UNITY_VERTEX_INPUT_INSTANCE_ID
            };


            struct VertexOutput
            {
                float2 uv           : TEXCOORD0;
                float4 clipPos      : SV_POSITION;
                // Interpolators defined by graph
                float3 WorldSpacePosition : TEXCOORD3;
                float3 WorldSpaceNormal : TEXCOORD4;
                float3 WorldSpaceTangent : TEXCOORD5;
                float3 WorldSpaceBiTangent : TEXCOORD6;
                float3 WorldSpaceViewDirection : TEXCOORD7;
                half4 uv1 : TEXCOORD8;

                UNITY_VERTEX_INPUT_INSTANCE_ID
                UNITY_VERTEX_OUTPUT_STEREO
            };

            float3 _LightDirection;

            VertexOutput ShadowPassVertex(GraphVertexInput v)
            {
                VertexOutput o;
                UNITY_SETUP_INSTANCE_ID(v);
                UNITY_TRANSFER_INSTANCE_ID(v, o);
                UNITY_INITIALIZE_VERTEX_OUTPUT_STEREO(o);

                // Vertex transformations performed by graph
                float3 WorldSpacePosition = mul(UNITY_MATRIX_M,v.vertex).xyz;
                float3 WorldSpaceNormal = normalize(mul(v.normal,(float3x3)UNITY_MATRIX_I_M));
                float3 WorldSpaceTangent = normalize(mul((float3x3)UNITY_MATRIX_M,v.tangent.xyz));
                float3 WorldSpaceBiTangent = cross(WorldSpaceNormal, WorldSpaceTangent.xyz) * v.tangent.w;
                float3 WorldSpaceViewDirection = _WorldSpaceCameraPos.xyz - mul(GetObjectToWorldMatrix(), float4(v.vertex.xyz, 1.0)).xyz;
                float4 uv1 = v.texcoord1;
                float3 ViewSpacePosition = mul(UNITY_MATRIX_V,float4(WorldSpacePosition,1.0)).xyz;

                VertexDescriptionInputs vdi = (VertexDescriptionInputs)0;

                // Vertex description inputs defined by graph
                vdi.WorldSpaceNormal = WorldSpaceNormal;
                vdi.WorldSpaceTangent = WorldSpaceTangent;
                vdi.WorldSpaceBiTangent = WorldSpaceBiTangent;
                vdi.WorldSpacePosition = WorldSpacePosition;
                vdi.ViewSpacePosition = ViewSpacePosition;

                VertexDescription vd = PopulateVertexData(vdi);
                v.vertex.xyz = vd.Position;

                // Vertex shader outputs defined by graph
                o.WorldSpacePosition = WorldSpacePosition;
                o.WorldSpaceNormal = WorldSpaceNormal;
                o.WorldSpaceTangent = WorldSpaceTangent;
                o.WorldSpaceBiTangent = WorldSpaceBiTangent;
                o.WorldSpaceViewDirection = WorldSpaceViewDirection;
                o.uv1 = uv1;


                float3 positionWS = TransformObjectToWorld(v.vertex.xyz);
                float3 normalWS = TransformObjectToWorldNormal(v.normal);

                float4 clipPos = TransformWorldToHClip(ApplyShadowBias(positionWS, normalWS, _LightDirection));

            #if UNITY_REVERSED_Z
                clipPos.z = min(clipPos.z, clipPos.w * UNITY_NEAR_CLIP_VALUE);
            #else
                clipPos.z = max(clipPos.z, clipPos.w * UNITY_NEAR_CLIP_VALUE);
            #endif
                o.clipPos = clipPos;

                return o;
            }

            half4 ShadowPassFragment(VertexOutput IN , half FaceSign : VFACE
        ) : SV_TARGET
            {
                UNITY_SETUP_INSTANCE_ID(IN);
                UNITY_SETUP_STEREO_EYE_INDEX_POST_VERTEX(IN);

                // Pixel transformations performed by graph
                float3 WorldSpacePosition = IN.WorldSpacePosition;
                float3 WorldSpaceNormal = IN.WorldSpaceNormal;
                float3 WorldSpaceTangent = IN.WorldSpaceTangent;
                float3 WorldSpaceBiTangent = IN.WorldSpaceBiTangent;
                float3 WorldSpaceViewDirection = IN.WorldSpaceViewDirection;
                float4 uv1 = IN.uv1;

                SurfaceDescriptionInputs surfaceInput = (SurfaceDescriptionInputs)0;

                // Surface description inputs defined by graph
                surfaceInput.FaceSign = FaceSign;

                SurfaceDescription surf = PopulateSurfaceData(surfaceInput);

                float Alpha = 1;
                float AlphaClipThreshold = 0;

                // Surface description remap performed by graph
                Alpha = surf.Alpha;
                AlphaClipThreshold = surf.AlphaClipThreshold;

         #if _AlphaClip
                clip(Alpha - AlphaClipThreshold);
        #endif
                return 0;
            }

            ENDHLSL
        }

        Pass
        {
            Name "DepthOnly"
            Tags{"LightMode" = "DepthOnly"}

            ZWrite On
            ColorMask 0

                // Material options generated by graph
                Cull Off

                HLSLPROGRAM
                // Required to compile gles 2.0 with standard srp library
                #pragma prefer_hlslcc gles
                #pragma exclude_renderers d3d11_9x
                #pragma target 2.0

                //--------------------------------------
                // GPU Instancing
                #pragma multi_compile_instancing

                #pragma vertex vert
                #pragma fragment frag

                // Defines generated by graph
                #define _AlphaClip 1

                #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Core.hlsl"
                #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/Lighting.hlsl"
                #include "Packages/com.unity.render-pipelines.lightweight/ShaderLibrary/ShaderGraphFunctions.hlsl"
                #include "Packages/com.unity.render-pipelines.core/ShaderLibrary/Color.hlsl"

                CBUFFER_START(UnityPerMaterial)
                float4 _OutlineColor;
                float _ScaleFactor;
                CBUFFER_END

                struct VertexDescriptionInputs
                {
                    float3 WorldSpaceNormal;
                    float3 WorldSpaceTangent;
                    float3 WorldSpaceBiTangent;
                    float3 WorldSpacePosition;
                    float3 ViewSpacePosition;
                };

                struct SurfaceDescriptionInputs
                {
                    float FaceSign;
                };


                void Unity_Absolute_float(float In, out float Out)
                {
                    Out = abs(In);
                }

                void Unity_Multiply_float(float A, float B, out float Out)
                {
                    Out = A * B;
                }

                void Unity_Divide_float(float A, float B, out float Out)
                {
                    Out = A / B;
                }

                void Unity_Multiply_float(float3 A, float3 B, out float3 Out)
                {
                    Out = A * B;
                }

                void Unity_Add_float3(float3 A, float3 B, out float3 Out)
                {
                    Out = A + B;
                }

                void Unity_Branch_float(float Predicate, float True, float False, out float Out)
                {
                    Out = lerp(False, True, Predicate);
                }

                struct VertexDescription
                {
                    float3 Position;
                };

                VertexDescription PopulateVertexData(VertexDescriptionInputs IN)
                {
                    VertexDescription description = (VertexDescription)0;
                    float _Property_90A48841_Out_0 = _ScaleFactor;
                    float _Split_39131A38_R_1 = IN.ViewSpacePosition[0];
                    float _Split_39131A38_G_2 = IN.ViewSpacePosition[1];
                    float _Split_39131A38_B_3 = IN.ViewSpacePosition[2];
                    float _Split_39131A38_A_4 = 0;
                    float _Absolute_CEDA0562_Out_1;
                    Unity_Absolute_float(_Split_39131A38_B_3, _Absolute_CEDA0562_Out_1);
                    float _Multiply_F0695E26_Out_2;
                    Unity_Multiply_float(_Property_90A48841_Out_0, _Absolute_CEDA0562_Out_1, _Multiply_F0695E26_Out_2);
                    float4 _MatrixSplit_1C48B3C9_M0_1 = UNITY_MATRIX_P[0];
                    float4 _MatrixSplit_1C48B3C9_M1_2 = UNITY_MATRIX_P[1];
                    float4 _MatrixSplit_1C48B3C9_M2_3 = UNITY_MATRIX_P[2];
                    float4 _MatrixSplit_1C48B3C9_M3_4 = UNITY_MATRIX_P[3];
                    float _Split_55F6C55D_R_1 = _MatrixSplit_1C48B3C9_M0_1[0];
                    float _Split_55F6C55D_G_2 = _MatrixSplit_1C48B3C9_M0_1[1];
                    float _Split_55F6C55D_B_3 = _MatrixSplit_1C48B3C9_M0_1[2];
                    float _Split_55F6C55D_A_4 = _MatrixSplit_1C48B3C9_M0_1[3];
                    float _Divide_3E0AC35C_Out_2;
                    Unity_Divide_float(_ScreenParams.x, _ScreenParams.y, _Divide_3E0AC35C_Out_2);
                    float _Multiply_6545A8C7_Out_2;
                    Unity_Multiply_float(_Split_55F6C55D_R_1, _Divide_3E0AC35C_Out_2, _Multiply_6545A8C7_Out_2);
                    float _Divide_8542C8F7_Out_2;
                    Unity_Divide_float(_Multiply_F0695E26_Out_2, _Multiply_6545A8C7_Out_2, _Divide_8542C8F7_Out_2);
                    float3 _Multiply_FEB093DF_Out_2;
                    Unity_Multiply_float((_Divide_8542C8F7_Out_2.xxx), IN.WorldSpaceNormal, _Multiply_FEB093DF_Out_2);
                    float3 _Add_133F45A4_Out_2;
                    Unity_Add_float3(_Multiply_FEB093DF_Out_2, IN.WorldSpacePosition, _Add_133F45A4_Out_2);
                    float3 _Transform_76279C8F_Out_1 = TransformWorldToObject(_Add_133F45A4_Out_2.xyz);
                    description.Position = _Transform_76279C8F_Out_1;
                    return description;
                }

                struct SurfaceDescription
                {
                    float Alpha;
                    float AlphaClipThreshold;
                };

                SurfaceDescription PopulateSurfaceData(SurfaceDescriptionInputs IN)
                {
                    SurfaceDescription surface = (SurfaceDescription)0;
                    float _IsFrontFace_5A59E25B_Out_0 = max(0, IN.FaceSign);
                    float _Branch_18FFF884_Out_3;
                    Unity_Branch_float(_IsFrontFace_5A59E25B_Out_0, 0, 1, _Branch_18FFF884_Out_3);
                    float _Vector1_252E6EF6_Out_0 = 0.5;
                    surface.Alpha = _Branch_18FFF884_Out_3;
                    surface.AlphaClipThreshold = _Vector1_252E6EF6_Out_0;
                    return surface;
                }

                struct GraphVertexInput
                {
                    float4 vertex : POSITION;
                    float3 normal : NORMAL;
                    float4 tangent : TANGENT;
                    float4 texcoord1 : TEXCOORD1;
                    UNITY_VERTEX_INPUT_INSTANCE_ID
                };


                struct VertexOutput
                {
                    float2 uv           : TEXCOORD0;
                    float4 clipPos      : SV_POSITION;
                    // Interpolators defined by graph
                    float3 WorldSpacePosition : TEXCOORD3;
                    float3 WorldSpaceNormal : TEXCOORD4;
                    float3 WorldSpaceTangent : TEXCOORD5;
                    float3 WorldSpaceBiTangent : TEXCOORD6;
                    float3 WorldSpaceViewDirection : TEXCOORD7;
                    half4 uv1 : TEXCOORD8;

                    UNITY_VERTEX_INPUT_INSTANCE_ID
                    UNITY_VERTEX_OUTPUT_STEREO
                };

                VertexOutput vert(GraphVertexInput v)
                {
                    VertexOutput o = (VertexOutput)0;
                    UNITY_SETUP_INSTANCE_ID(v);
                    UNITY_TRANSFER_INSTANCE_ID(v, o);
                    UNITY_INITIALIZE_VERTEX_OUTPUT_STEREO(o);

                    // Vertex transformations performed by graph
                    float3 WorldSpacePosition = mul(UNITY_MATRIX_M,v.vertex).xyz;
                    float3 WorldSpaceNormal = normalize(mul(v.normal,(float3x3)UNITY_MATRIX_I_M));
                    float3 WorldSpaceTangent = normalize(mul((float3x3)UNITY_MATRIX_M,v.tangent.xyz));
                    float3 WorldSpaceBiTangent = cross(WorldSpaceNormal, WorldSpaceTangent.xyz) * v.tangent.w;
                    float3 WorldSpaceViewDirection = _WorldSpaceCameraPos.xyz - mul(GetObjectToWorldMatrix(), float4(v.vertex.xyz, 1.0)).xyz;
                    float4 uv1 = v.texcoord1;
                    float3 ViewSpacePosition = mul(UNITY_MATRIX_V,float4(WorldSpacePosition,1.0)).xyz;

                    VertexDescriptionInputs vdi = (VertexDescriptionInputs)0;

                    // Vertex description inputs defined by graph
                    vdi.WorldSpaceNormal = WorldSpaceNormal;
                    vdi.WorldSpaceTangent = WorldSpaceTangent;
                    vdi.WorldSpaceBiTangent = WorldSpaceBiTangent;
                    vdi.WorldSpacePosition = WorldSpacePosition;
                    vdi.ViewSpacePosition = ViewSpacePosition;

                    VertexDescription vd = PopulateVertexData(vdi);
                    v.vertex.xyz = vd.Position;

                    // Vertex shader outputs defined by graph
                    o.WorldSpacePosition = WorldSpacePosition;
                    o.WorldSpaceNormal = WorldSpaceNormal;
                    o.WorldSpaceTangent = WorldSpaceTangent;
                    o.WorldSpaceBiTangent = WorldSpaceBiTangent;
                    o.WorldSpaceViewDirection = WorldSpaceViewDirection;
                    o.uv1 = uv1;

                    o.clipPos = TransformObjectToHClip(v.vertex.xyz);
                    return o;
                }

                half4 frag(VertexOutput IN , half FaceSign : VFACE
            ) : SV_TARGET
                {
                    UNITY_SETUP_INSTANCE_ID(IN);
                    UNITY_SETUP_STEREO_EYE_INDEX_POST_VERTEX(IN);

                    // Pixel transformations performed by graph
                    float3 WorldSpacePosition = IN.WorldSpacePosition;
                    float3 WorldSpaceNormal = IN.WorldSpaceNormal;
                    float3 WorldSpaceTangent = IN.WorldSpaceTangent;
                    float3 WorldSpaceBiTangent = IN.WorldSpaceBiTangent;
                    float3 WorldSpaceViewDirection = IN.WorldSpaceViewDirection;
                    float4 uv1 = IN.uv1;

                    SurfaceDescriptionInputs surfaceInput = (SurfaceDescriptionInputs)0;

                    // Surface description inputs defined by graph
                    surfaceInput.FaceSign = FaceSign;

                    SurfaceDescription surf = PopulateSurfaceData(surfaceInput);

                    float Alpha = 1;
                    float AlphaClipThreshold = 0;

                    // Surface description remap performed by graph
                    Alpha = surf.Alpha;
                    AlphaClipThreshold = surf.AlphaClipThreshold;

             #if _AlphaClip
                    clip(Alpha - AlphaClipThreshold);
            #endif
                    return 0;
                }
                ENDHLSL
            }
    }
        FallBack "Hidden/InternalErrorShader"
}
